#ifndef DEBUG_TOOLS_HEADER
	#define DEBUG_TOOLS_HEADER

#include "main.h"  // Da ist Auch 
/*
Beispiel:
uart_puts( ByteToBin( gu8DS1337_Status )); uart_putc(13);		
Toggle_Bit(2);
*/

// ***  Schalte ein was du brauchst  ***
#define TOGGLE_FLAG_USED
//#define TOGGLE_STATIC_BIT_USED
#define BYTE_TO_BIN_USED
//#define WORD_TO_BIN_USED
#define BYTE_TO_HEX_USED

#ifdef TOGGLE_FLAG_USED	// INDIVIDUEL EINSTELLEN
	#define TOGGLE_PIN		4  //Pin Nummer
	#define TOGGLE_PORT		PORTB
	#define TOGGLE_DIRREG	DDRB
	#define TOGGLE_BIT		(1<<TOGGLE_PIN)
#endif

#ifdef TOGGLE_FLAG_USED
extern void Toggle_Bit(uint8_t u8Cnt);
#endif

#ifdef TOGGLE_STATIC_BIT_USED
extern void Toggle_On(void);
extern void Toggle_Off(void);
#endif

#ifdef BYTE_TO_BIN_USED
extern char * ByteToBin(uint8_t u8Byte);
#endif

#ifdef WORD_TO_BIN_USED
extern char * WordToBin(uint16_t u16Word);
#endif


#ifdef BYTE_TO_HEX_USED
extern char * ByteToHex(uint8_t u8Byte);
#endif

#ifdef SHOW_BYTE_USED
extern void ShowByte(uint8_t u8Byte, char * pText, uint8_t u8Nr);
#endif


//void ShowByte(uint8_t u8Byte, uint8_t u8Nr);

#endif //DEBUG_TOOLS_HEADER