

//FEHLER NICHT DDRO=0 PORT AUF 1 SCHALTEN, WEIL PULLUP

//https://en.wikipedia.org/wiki/Charlieplexing
//http://www.elektronik-labor.de/AVR/Charlieplexing.html

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

/*
Device signature = 0x1e950f

-F in AVerdude um das zu ignorieren  HILFT??
avrdude: warning: cannot set sck period. please check for usbasp firmware update
*/


#define SOFTWARE	"SparkFun_LED_8x7"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"07.01.2019"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"


#include "main.h"
//#include "font5x8.h"

uint8_t gu8ParkFun[FONT_HEIGHT];  //8    7 Teilen, 8 Spalten, 1 Bit=selector
volatile uint32_t gu32_Ticks;
volatile uint8_t gu8StatusFlags=0;
volatile uint8_t gu8Spark8x7Flags=0;

// PROTO
void FetchZeichen(uint8_t u8Char);
void ByteToMatrix(uint8_t u8Row);
void ByteToLED(uint8_t u8Row);
void ShowByte(uint8_t u8Byte, char * pText, uint8_t u8Nr);
void Led7x8_Sinus(float fTT );

// ********************************
ISR( TIMER0_OVF_vect )
// ********************************
{
uint8_t u8sreg=SREG;
static volatile uint8_t gu8RowNN=0;

static volatile uint32_t gu32_TickComp;
static volatile uint32_t gu32_ZeichenComp;
gu32_Ticks++;
if( (gu32_Ticks - gu32_TickComp) > TICK_1000MS)
	{
	gu32_TickComp = gu32_Ticks;		
	gu8StatusFlags |= TICK_EVENT;		
	};

if( (gu32_Ticks - gu32_ZeichenComp) > TICK_500MS)  //110sec
	{
	gu32_ZeichenComp = gu32_Ticks;
	gu8StatusFlags |= ZEICHEN_EVENT;
	};


ByteToMatrix(gu8RowNN);
gu8RowNN++;		
gu8RowNN %= FONT_HEIGHT; //8

SREG = u8sreg;
};

// *************************
ISR( TIMER0_COMPA_vect )
// *************************
{
A_F_DDR &= ~A_F_PORT_MASK;
G_H_DDR &= ~G_H_PORT_MASK;
A_F_PORT &= ~A_F_PORT_MASK;
G_H_PORT &= ~G_H_PORT_MASK;
};

/*
// *************************
void ByteToLED(uint8_t u8Byte)
// *************************
{
A_F_DDR |= A_F_PORT_MASK;
G_H_DDR	|= G_H_PORT_MASK;
A_F_PORT &= ~A_F_PORT_MASK;
G_H_PORT &= ~G_H_PORT_MASK;
A_F_PORT |= ( (u8Byte & A_F_DATA_MASK) << A_F_DATA_SHIFT_NR) & A_F_PORT_MASK;
G_H_PORT |= ( (u8Byte & G_H_DATA_MASK) >> G_H_DATA_SHIFT_NR) & G_H_PORT_MASK;
};
*/

// ********************************
void ByteToMatrix(uint8_t u8Row)
// ********************************
{
uint8_t u8Split_Low_Data;
uint8_t u8Split_High_Data;
uint8_t u8SParkFun8x7Data;
uint8_t u8Low_0_Maske;
uint8_t u8High_0_Maske;

//Data sind schon "left flush"
u8Low_0_Maske	= (1<<u8Row) - 1; 					//bsp3: 1000-"1"=00000111
u8High_0_Maske	= ~(1<<u8Row) & ~u8Low_0_Maske;   // 11110111  & ~00000111   = 11110000

// +5V Selektiert Reihe, 
// 0V = LED ON
u8Split_Low_Data = ((gu8ParkFun[u8Row]) >> 1) & u8Low_0_Maske;
u8Split_High_Data = gu8ParkFun[u8Row]  &  u8High_0_Maske;
u8SParkFun8x7Data = (u8Split_High_Data | u8Split_Low_Data) | (1<<u8Row);
	
//lsche Port	
A_F_DDR &= ~A_F_PORT_MASK;
G_H_DDR &= ~G_H_PORT_MASK;
A_F_PORT &= ~A_F_PORT_MASK;
G_H_PORT &= ~G_H_PORT_MASK;
//NEUE DATEN
if( u8Row < 6)
	{
	A_F_DDR |= (((u8SParkFun8x7Data & A_F_DATA_MASK) | (1<<u8Row) ) << A_F_DATA_SHIFT_NR) & A_F_PORT_MASK ;
	G_H_DDR |= ((u8SParkFun8x7Data & G_H_DATA_MASK) >> G_H_DATA_SHIFT_NR) & G_H_PORT_MASK;
	A_F_PORT |= ((~A_F_DDR) | ((1<<u8Row) << A_F_DATA_SHIFT_NR))  & A_F_PORT_MASK;
	G_H_PORT |= (~G_H_DDR) & G_H_PORT_MASK;	
	}
else
	{
	A_F_DDR |= ((u8SParkFun8x7Data & A_F_DATA_MASK) << A_F_DATA_SHIFT_NR) & A_F_PORT_MASK ;
	G_H_DDR |= (((u8SParkFun8x7Data & G_H_DATA_MASK) | (1<<u8Row)) >> G_H_DATA_SHIFT_NR) & G_H_PORT_MASK;
	A_F_PORT |= (~A_F_DDR) & A_F_PORT_MASK;
	G_H_PORT |= ((~G_H_DDR) | ((1<<u8Row) >> G_H_DATA_SHIFT_NR)) & G_H_PORT_MASK;
	};

/*	//Debuggng
	gu8StatusFlags &= ~ZEICHEN_EVENT;		
	ShowByte(u8Low_0_Maske, "LMSK", u8Row);
	ShowByte(u8High_0_Maske, "HMSK", u8Row);
	ShowByte(u8Split_Low_Data, "LDat", u8Row);
	ShowByte(u8Split_High_Data, "HDat", u8Row);
	ShowByte(u8SParkFun8x7Data, "Full", u8Row);
	ShowByte(gu8ParkFun[u8Row], "ORG", u8Row);
	ShowByte(A_F_DDR , "DDAF", u8Row);
	ShowByte(G_H_DDR , "DDGH", u8Row);
	ShowByte(A_F_PORT , "POAF", u8Row);
	ShowByte(G_H_PORT , "POGH", u8Row);
*/
};


// ********************************
void FetchZeichen(uint8_t u8Char)
// ********************************
{
uint8_t u8NN;
uint8_t u8aOrgField[FONT_WIDTH]; //7

for(u8NN=0; u8NN < 8; u8NN++)
	{
	//'A'=65  ('A'-32)*7
	u8aOrgField[u8NN] = pgm_read_byte_near(cmaFont7x8 + ((u8Char - FONT_CHAR_FIRST) * FONT_WIDTH) + u8NN);
	};
//lsche BIFfeld
for(u8NN=0;u8NN < FONT_HEIGHT; u8NN++)//8
	{		
	gu8ParkFun[u8NN] = 0;
	};
//Drehe Bitfeld nach Links und Spiegele
//Linksbndig
for(u8NN=0; u8NN < FONT_WIDTH; u8NN++) //7
	{		
	if(u8aOrgField[u8NN] & 0x01) {gu8ParkFun[0] |= (1<<(7-u8NN));};
	if(u8aOrgField[u8NN] & 0x02) {gu8ParkFun[1] |= (1<<(7-u8NN));};
	if(u8aOrgField[u8NN] & 0x04) {gu8ParkFun[2] |= (1<<(7-u8NN));};
	if(u8aOrgField[u8NN] & 0x08) {gu8ParkFun[3] |= (1<<(7-u8NN));};
	if(u8aOrgField[u8NN] & 0x10) {gu8ParkFun[4] |= (1<<(7-u8NN));};
	if(u8aOrgField[u8NN] & 0x20) {gu8ParkFun[5] |= (1<<(7-u8NN));};
	if(u8aOrgField[u8NN] & 0x40) {gu8ParkFun[6] |= (1<<(7-u8NN));};
	};
gu8ParkFun[7] = 0;
};


//statisch  PLUS = Zeile 
// *******************
int main(void)
// *******************
{
uint8_t u8XX = 0;
INTLED_DDR |= INTLED_BIT | PD1_TX_BIT;
PORTD = PD1_TX_BIT | PD0_RX_BIT;
uart_init( UART_BAUD_SELECT( UART_BAUD_RATE, F_CPU ) );// !! Init UART interface

OCR0A = LEX7x8_PWM;
TCCR0A = 0;
TIMSK0 = (1<<TOIE0) | (1<<OCIE0A);   //OVL0 & Comp0A
TCCR0B = (1<<CS01)| (1<<CS00); // F_CPU/256/64= 977
wdt_enable( WDTO_1S );
	
//DEBUGPRINT
for(;;)
	{
	sei();
	wdt_reset();   //WATCHDOG!		
	if( gu8StatusFlags & TICK_EVENT )
		{		 
		gu8StatusFlags &= ~TICK_EVENT;
		TOGGLE_INTLED();
		}; //TICK

	if( gu8StatusFlags & ZEICHEN_EVENT )
		{		 		
		gu8StatusFlags &= ~ZEICHEN_EVENT;	
		FetchZeichen( 32 + u8XX );	
			u8XX++;
			u8XX %= 95;		
		};
	
	UART_RX_Check();
	if( gu8StatusFlags  & ORDER_FLAG )
		{
		// Ausgelagert wegen InterruptZeit
		CheckOrder();//gcaRxStr = accumulated str
		ResetRxBuff();
		gu8StatusFlags &= ~ORDER_FLAG;
		};
	}; //while
}; //main

/*
Bin	Hex
0000	0
0001	1
0010	2
0011	3
0100	4
0101	5
0110	6
0111	7
1000	8
1001	9
1010	A-10
1011	B-11
1011	B-11
1100	C-12
1101	D-13
1110	E-14
1111	F-15
*/
